#lang racket
(require "curses.rkt")

(define win (initscr))
(check-error (noecho))
(check-error (cbreak))

(void (mousemask BUTTON1_CLICKED #f))
(check-error (keypad win #t))

(check-error (waddstr win "Password: "))
(check-error (wrefresh win))

(define (get-password)
  (define ch (wgetch win))
  (cond
   [(= ch -1) (check-error 1)]
   [(= ch (char->integer #\newline)) empty]
   [(= ch KEY_MOUSE)
    (define m (make-MEVENT 0 0 0 0 0))
    (check-error (getmouse m))
    (define x (getcurx win))
    (define y (getcury win))
    (wmove win 1 0)
    (waddstr win (format "Mouse at ~s, ~s" (MEVENT-x m) (MEVENT-y m)))
    (check-error (wmove win y x))
    (wrefresh win)
    (get-password)]
   [else (cons (integer->char ch)
               (get-password))]))

(define pw (list->string (get-password)))

(void (endwin))

;; Print password result, now that the screen is closed:
pw
